"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Entry = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const mkdirp_1 = __importDefault(require("mkdirp"));
const util_1 = require("util");
const writeFileAsync = util_1.promisify(fs_1.default.writeFile);
const TEMPATE_HOT = (key) => `import fn from './${key}';
fn();
if (module.hot) {
  module.hot.accept('./${key}', () => {
    fn();
  });
}`;
const TEMPLATE_ROOT = (code) => `export default function() { ${code || ""}}`;
const TEMPLATE_ROOT_REQUIRE = (relPath) => `export  default function() { const fn = require('${relPath}').defaults; fn && fn();}`;
class Entry {
    constructor(options) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        this.options = options;
        this.name = this.options.name;
        this.nameJS = `${this.name}.js`;
        this.relPath = path_1.default.relative(path_1.default.dirname(path_1.default.join(this.options.SRC, this.name)), path_1.default.join(this.options.packsDirectory, this.name));
        this.nameJS_HOT = `${this.name}_$.js`;
        this.url = path_1.default.join(this.options.publicPath, this.nameJS);
        this.path = path_1.default.join(this.options.SRC, this.nameJS_HOT);
        this.TEMPLATE_ROOT_REQUIRE = (_c = (_b = (_a = this.options).TEMPLATE_ROOT_REQUIRE) === null || _b === void 0 ? void 0 : _b.call(_a, this.relPath)) !== null && _c !== void 0 ? _c : TEMPLATE_ROOT_REQUIRE(this.relPath);
        this.TEMPATE_HOT = (_f = (_e = (_d = this.options).TEMPATE_HOT) === null || _e === void 0 ? void 0 : _e.call(_d, path_1.default.basename(this.nameJS_HOT))) !== null && _f !== void 0 ? _f : TEMPATE_HOT(path_1.default.basename(this.nameJS_HOT));
        this.TEMPLATE_ROOT = (_k = (_h = (_g = this.options).TEMPLATE_ROOT) === null || _h === void 0 ? void 0 : _h.call(_g, (_j = this.options.code) !== null && _j !== void 0 ? _j : "")) !== null && _k !== void 0 ? _k : TEMPLATE_ROOT((_l = this.options.code) !== null && _l !== void 0 ? _l : "");
        this.writeFileAsyncNotify = (_m = this.options.writeFileAsyncNotify) !== null && _m !== void 0 ? _m : writeFileAsync;
        if (/\.js$/.test(options.name)) {
            throw new Error(`Invalid entry name: ${options.name}`);
        }
    }
    test(url) {
        return this.name === url || this.url === url || this.nameJS === url;
    }
    createHot() {
        const filepath = path_1.default.join(this.options.SRC, this.nameJS);
        const hotFolder = path_1.default.dirname(filepath);
        return mkdirp_1.default(hotFolder).then(() => this.writeFileAsyncNotify(filepath, this.TEMPATE_HOT));
    }
    create(state) {
        this.state = state;
        const content = state === "fill" ? this.TEMPLATE_ROOT_REQUIRE : this.TEMPLATE_ROOT;
        return new Promise((resolve) => {
            setTimeout(() => {
                this.writeFileAsyncNotify(this.path, content);
                resolve();
            }, 10);
        });
    }
}
exports.Entry = Entry;
//# sourceMappingURL=Entry.js.map