import webpack from "webpack";
import { Entry } from "./Entry";
export interface IEntryListOptions {
    SRC: string;
    packsDirectory: string;
    code?: string;
    host: string;
    config: webpack.Configuration;
    acceptFile?: (val: string) => boolean;
    hotMiddlewareOptions?: Record<string, string>;
}
export default class EntryList {
    private options;
    readonly entries: Entry[];
    private _publicPath;
    get publicPath(): string;
    private constructor();
    static build(options: IEntryListOptions): Promise<{
        compiler: webpack.Compiler;
        config: webpack.Configuration;
        instance: EntryList;
    }>;
    create(url: string, mode: "fill" | "empty"): Promise<void>;
    private setup;
    private clearFolder;
    private createFolder;
}
